//+------------------------------------------------------------------+
//|                                                       MaDuet.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double sper = 9;
extern double mper = 18;
extern double fper = 36;
extern double delta = 5;
extern double uwprs = 25;
extern double uwprb = 75;
extern double mBars = 300;

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;
double ExtHistoBuffer[];
double ExtHistoBuffer2[];

void SetLoopCount(int loops)
{
}
void SetIndexValue(int shift, double value)
{
  ExtHistoBuffer[shift] = value;
}
void SetIndexValue2(int shift, double value)
{
  ExtHistoBuffer2[shift] = value;
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+
int init()
{
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, ExtHistoBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1, ExtHistoBuffer2);
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
int shift = 0;
double FMa = 0;
double MMa = 0;
double SMa = 0;
double WPR1 = 0;
double WPR0 = 0;

SetLoopCount(0);
// loop from first bar to current bar (with shift=0)
for(shift=Bars-1;shift>=0 ;shift--){ SetIndexValue(shift,0);SetIndexValue2(shift,0);} 

for(shift=mBars;shift>=1 ;shift--){ 
  MMa=iMA(NULL, 0, mper, 0, MODE_EMA, PRICE_CLOSE, shift);
  SMa=iMA(NULL, 0, sper, 0, MODE_EMA, PRICE_CLOSE, shift);
  FMa=iMA(NULL, 0, fper, 0, MODE_EMA, PRICE_CLOSE, shift);
  
SetIndexValue(shift,SMa);SetIndexValue2(shift,FMa);
  
  WPR1=iWPR(NULL,0,14,1);WPR0=iWPR(NULL,0,14,0);
  
if( SMa-FMa>=delta*Point && Close[2]>Close[1] && FMa-Close[1]>=delta*Point && 
   FMa-Close[1]<=2*delta*Point && MMa>FMa && MMa<SMa && WPR0>-uwprs && WPR0<WPR1 ); 
   
if( FMa-SMa>=delta*Point && Close[2]<Close[1] && Close[1]-FMa>=delta*Point && 
   Close[1]-FMa<=2*delta*Point && MMa<FMa && MMa>SMa && WPR0<-uwprb && WPR0>WPR1 );
   } 
  return(0);
}